﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using J2534;
using Microsoft.Win32;
using System.Runtime.InteropServices;

namespace E55Tool
{
    class Program
    {

        static void Main(string[] args)
        {
            /*
                        // Find Devices in Registry & Load Library
                        List<J2534.J2534Device> installedDLLs = new List<J2534.J2534Device>();
                        string PASSTHRU_REGISTRY_PATH = "Software\\PassThruSupport.04.04";
                        RegistryKey myKey = Registry.LocalMachine.OpenSubKey(PASSTHRU_REGISTRY_PATH, false);
                        string[] devices = myKey.GetSubKeyNames();

                        foreach (string device in devices)
                        {
                            J2534.J2534Device tempDevice = new J2534.J2534Device();
                            RegistryKey deviceKey = myKey.OpenSubKey(device);

                            if ((deviceKey == null))
                            {
                                continue; //Skip device... its empty
                            }

                            tempDevice.FunctionLibrary = (string)deviceKey.GetValue("FunctionLibrary", "");
                            tempDevice.Name = (string)deviceKey.GetValue("Name", "");
                            installedDLLs.Add(tempDevice);
                           // Console.WriteLine(tempDevice.FunctionLibrary);

                           E55.LoadLibrary(tempDevice);

                        }
            */

            PassThruMsg TempMsg = new PassThruMsg();
            J2534.J2534DllWrapper E55Tool = new J2534.J2534DllWrapper();

            E55Tool.LoadJ2534Library("C:\\ProgramData\\VCX\\Apps\\PASSTHRU\\VCXPT32.dll");
           

            Console.WriteLine("Loading Library\n");


            uint deviceID = 1;
            int ChannelID = 1;
            int Timeout = 2000;


            // Open Device
            E55Tool.Open(IntPtr.Zero, ref deviceID);
            Console.WriteLine("Connection Open");


            // Connect to Device
            E55Tool.Connect(deviceID, J2534.ProtocolID.CAN, J2534.ConnectFlag.CAN_ID_BOTH, J2534.BaudRate.CAN_500000, ref deviceID);
            Console.WriteLine("Connect\n");


            //Setup Filters
            int FilterID = 1;
            IntPtr FlowPtr = IntPtr.Zero;
            PassThruMsg patternMsg = new PassThruMsg(J2534.ProtocolID.CAN, J2534.TxFlag.NONE, new Byte[] { 0x00, 0x00, 0x00, 0x00 });
            IntPtr PatternPtr = patternMsg.ToIntPtr();
            int Filter = E55Tool.StartMsgFilter(ChannelID, 1, PatternPtr, PatternPtr, FlowPtr, ref FilterID);
            Console.WriteLine("Setup Filters: " + Filter);


            // TEST Write Messages 
            byte[] writemessage = {0x00, 0x00, 0x07, 0xE0, 0x02, 0x1A, 0x90};
            TempMsg.ProtocolID = J2534.ProtocolID.CAN;
            TempMsg.TxFlags = J2534.TxFlag.NONE;
            TempMsg.SetBytes(writemessage);
            int NumMsgstoWrite = 1;
            IntPtr MsgPtr = TempMsg.ToIntPtr();
            int Send = E55Tool.WriteMsgs((int)ChannelID, MsgPtr, ref NumMsgstoWrite, Timeout);
            Marshal.FreeHGlobal(MsgPtr);
            Console.WriteLine("Message to Send: " + BitConverter.ToString(writemessage) + "\nMessage Sent: " + Send);


            // Read Messages
            int NumMsgstoRead = 1;
            IntPtr msgread = Marshal.AllocHGlobal((int)(Marshal.SizeOf(typeof(PassThruMsg)) * NumMsgstoRead));
            TempMsg = msgread.AsMsgList(1).Last();
            int Read = E55Tool.ReadMsgs(ChannelID, msgread, ref NumMsgstoRead, Timeout);
            Console.WriteLine("Read: " + Read);


            // Close Filters
            E55Tool.StopMsgFilter(ChannelID, FilterID);
            Console.WriteLine("\nClear Filters");


            // Close Device
            E55Tool.Close(deviceID);
            Console.WriteLine("Close Device Connection");


            //Free Library
            E55Tool.FreeLibrary();
            Console.WriteLine("Close Library");

            /* VZ SEED KEY
            int seed = 0xD734;
            int key = seed - 0x3808;
            key &= 0xFFFF;
            Console.WriteLine(key);
            key = Convert.ToInt32(Console.ReadLine());

            key += 0xF294;
            key &= 0xFFFF;
            key = (key >> 2);
            key = (key << 3);
            Console.WriteLine(key);
             */


        }
    }
}
